library access_token;

import 'dart:convert';

import 'package:account_kit/serializers.dart';
import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'accessToken.g.dart';

abstract class AccessToken implements Built<AccessToken, AccessTokenBuilder> {
  AccessToken._();

  factory AccessToken([updates(AccessTokenBuilder b)]) = _$AccessToken;

  @BuiltValueField(wireName: 'id')
  int get id;
  @BuiltValueField(wireName: 'userID')
  int get userID;
  @BuiltValueField(wireName: 'name')
  String get name;
  @BuiltValueField(wireName: 'token')
  String get token;
  @BuiltValueField(wireName: 'validTo')
  String get validTo;
  @BuiltValueField(wireName: 'createdAt')
  String get createdAt;
  @BuiltValueField(wireName: 'updatedAt')
  String get updatedAt;
  @BuiltValueField(wireName: 'userName')
  String get userName;
  String toJson() {
    return json.encode(serializers.serializeWith(AccessToken.serializer, this));
  }

  static AccessToken? fromJson(String jsonString) {
    return serializers.deserializeWith(
        AccessToken.serializer, json.decode(jsonString));
  }

  static BuiltList<AccessToken> listFromJson(jsonString) {
    return BuiltList<AccessToken>.from(json
        .decode(jsonString)
        .map((value) =>
            serializers.deserializeWith(AccessToken.serializer, value))
        .toList());
  }

  static Serializer<AccessToken> get serializer => _$accessTokenSerializer;
}
