library app;

import 'dart:convert';

import 'package:account_kit/serializers.dart';
import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'app.g.dart';

abstract class App implements Built<App, AppBuilder> {
  App._();

  factory App([updates(AppBuilder b)]) = _$App;

  @BuiltValueField(wireName: 'id')
  int get id;
  @BuiltValueField(wireName: 'name')
  String? get name;
  @BuiltValueField(wireName: 'color')
  String? get color;
  @BuiltValueField(wireName: 'icon')
  String? get icon;
  @BuiltValueField(wireName: 'url')
  String? get url;
  @BuiltValueField(wireName: 'createdAt')
  String get createdAt;
  @BuiltValueField(wireName: 'updatedAt')
  String get updatedAt;
  String toJson() {
    return json.encode(serializers.serializeWith(App.serializer, this));
  }

  static App? fromJson(String jsonString) {
    return serializers.deserializeWith(App.serializer, json.decode(jsonString));
  }

  static BuiltList<App> listFromJson(jsonString) {
    return BuiltList<App>.from(json
        .decode(jsonString)
        .map((value) => serializers.deserializeWith(App.serializer, value))
        .toList());
  }

  static Serializer<App> get serializer => _$appSerializer;
}
