library group;

import 'dart:convert';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

import '../../serializers.dart';

part 'group.g.dart';

abstract class Group implements Built<Group, GroupBuilder> {
  Group._();

  factory Group([updates(GroupBuilder b)]) = _$Group;

  @BuiltValueField(wireName: 'id')
  int? get id;

  @BuiltValueField(wireName: 'name')
  String? get name;

  @BuiltValueField(wireName: 'organizationID')
  int? get organizationID;

  @BuiltValueField(wireName: 'order')
  int? get order;

  String toJson() {
    return json.encode(serializers.serializeWith(Group.serializer, this));
  }

  static Group? fromJson(String jsonString) {
    return serializers.deserializeWith(
        Group.serializer, json.decode(jsonString));
  }

  static BuiltList<Group> listFromJson(jsonString) {
    return BuiltList<Group>.from(json
        .decode(jsonString)
        .map((value) => serializers.deserializeWith(Group.serializer, value))
        .toList());
  }

  static Serializer<Group> get serializer => _$groupSerializer;
}
