library organization;

import 'dart:convert';

import 'package:account_kit/serializers.dart';
import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'organization.g.dart';

abstract class Organization
    implements Built<Organization, OrganizationBuilder> {
  Organization._();

  factory Organization([updates(OrganizationBuilder b)]) = _$Organization;

  @BuiltValueField(wireName: 'id')
  int get id;
  @BuiltValueField(wireName: 'ownerID')
  int? get ownerID;
  @BuiltValueField(wireName: 'name')
  String? get name;
  @BuiltValueField(wireName: 'logo')
  String? get logo;
  @BuiltValueField(wireName: 'token')
  String? get token;
  @BuiltValueField(wireName: 'organizationType')
  String? get organizationType;
  @BuiltValueField(wireName: 'referenceID')
  int? get referenceID;
  @BuiltValueField(wireName: 'default')
  bool? get defaultOrg;
  @BuiltValueField(wireName: 'active')
  bool? get active;
  @BuiltValueField(wireName: 'ownerFullName')
  String? get ownerFullName;
  @BuiltValueField(wireName: 'ownerEmail')
  String? get ownerEmail;
  String toJson() {
    return json
        .encode(serializers.serializeWith(Organization.serializer, this));
  }

  static Organization? fromJson(String jsonString) {
    return serializers.deserializeWith(
        Organization.serializer, json.decode(jsonString));
  }

  static BuiltList<Organization> listFromJson(jsonString) {
    return BuiltList<Organization>.from(json
        .decode(jsonString)
        .map((value) =>
            serializers.deserializeWith(Organization.serializer, value))
        .toList());
  }

  static Serializer<Organization> get serializer => _$organizationSerializer;
}
