library request;

import 'dart:convert';

import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

import '../../serializers.dart';

part 'request.g.dart';

abstract class Request implements Built<Request, RequestBuilder> {
  Request._();

  factory Request([updates(RequestBuilder b)]) = _$Request;

  @BuiltValueField(wireName: 'id')
  int get id;
  @BuiltValueField(wireName: 'firstName')
  String? get firstName;
  @BuiltValueField(wireName: 'lastName')
  String? get lastName;
  @BuiltValueField(wireName: 'email')
  String get email;
  @BuiltValueField(wireName: 'phone')
  String get phone;
  @BuiltValueField(wireName: 'organizationID')
  int? get organizationID;
  @BuiltValueField(wireName: 'organizationToken')
  String? get organizationToken;
  @BuiltValueField(wireName: 'inviteToken')
  String? get inviteToken;
  @BuiltValueField(wireName: 'defaultAppID')
  int? get defaultAppID;
  @BuiltValueField(wireName: 'active')
  bool? get active;
  @BuiltValueField(wireName: 'uuid')
  String? get uuid;
  @BuiltValueField(wireName: 'icon')
  String? get icon;
  @BuiltValueField(wireName: 'text')
  String? get text;
  @BuiltValueField(wireName: 'ValidationRequired')
  bool get validationRequired;
  @BuiltValueField(wireName: 'password')
  String get password;
  String toJson() {
    return json.encode(serializers.serializeWith(Request.serializer, this));
  }

  static Request? fromJson(String jsonString) {
    return serializers.deserializeWith(
        Request.serializer, json.decode(jsonString));
  }

  static Serializer<Request> get serializer => _$requestSerializer;
}
