library services;

import 'dart:convert';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

import '../../serializers.dart';

part 'services.g.dart';

abstract class Services implements Built<Services, ServicesBuilder> {
  Services._();

  factory Services([updates(ServicesBuilder b)]) = _$Services;
  @BuiltValueField(wireName: 'account')
  BuiltList<String>? get account;
  String toJson() {
    return json.encode(serializers.serializeWith(Services.serializer, this));
  }

  static Services? fromJson(String jsonString) {
    return serializers.deserializeWith(
        Services.serializer, json.decode(jsonString));
  }

  static Serializer<Services> get serializer => _$servicesSerializer;
}
