import 'dart:convert';

import 'package:account_kit/entities/accessToken/accessToken.dart';
import 'package:account_kit/serializers.dart';
import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'accessTokenState.g.dart';

abstract class AccessTokenState
    implements Built<AccessTokenState, AccessTokenStateBuilder> {
  AccessTokenState._();
  factory AccessTokenState([updates(AccessTokenStateBuilder b)]) =
      _$AccessTokenState;

  static AccessTokenState initial() {
    return new AccessTokenState(
        (b) => b..accessTokensByID = MapBuilder<int, AccessToken>());
  }

  BuiltList<AccessToken>? get accessTokens;
  BuiltMap<int, AccessToken>? get accessTokensByID;
  AccessToken? get biometricAccessToken;

  String toJson() {
    return json
        .encode(serializers.serializeWith(AccessTokenState.serializer, this));
  }

  static AccessTokenState? fromJson(jsonString) {
    return serializers.deserializeWith(
        AccessTokenState.serializer, json.decode(jsonString));
  }

  static Serializer<AccessTokenState> get serializer =>
      _$accessTokenStateSerializer;
}
