import 'package:account_kit/redux/accessToken/accessTokenReducer.dart';
import 'package:account_kit/redux/accountKitActions.dart';
import 'package:account_kit/redux/accountKitState.dart';
import 'package:account_kit/redux/app/appReducer.dart';
import 'package:account_kit/redux/group/groupReducer.dart';
import 'package:account_kit/redux/organization/organizationReducer.dart';
import 'package:account_kit/redux/user/userReducer.dart';
import 'package:redux/redux.dart';

final accountKitReducer = combineReducers<AccountKitState>([
  partialAccountKitReducer,
  TypedReducer<AccountKitState, InitAccountKitAction>(_initAccountKit),
]);

AccountKitState _initAccountKit(
    AccountKitState state, InitAccountKitAction action) {
  return state.rebuild((b) => b..prefix = action.prefix);
}

AccountKitState partialAccountKitReducer(AccountKitState state, action) {
  return state.rebuild((b) => b
    ..appState.replace(appReducer(state.appState, action))
    ..groupState.replace(groupReducer(state.groupState, action))
    ..userState.replace(userReducer(state.userState, action))
    ..accessTokenState
        .replace(accessTokenReducer(state.accessTokenState, action))
    ..organizationState
        .replace(organizationReducer(state.organizationState, action)));
}
