import 'package:account_kit/redux/app/appActions.dart';
import 'package:redux/redux.dart';

import 'appState.dart';

final appReducer = combineReducers<AppState>([
  TypedReducer<AppState, GetAppsSuccessAction>(_getAppsSuccess),
  TypedReducer<AppState, GetAppByIDSuccessAction>(_getAppByIDSuccess),
  TypedReducer<AppState, DeleteAppSuccessAction>(_deleteAppSuccess),
  TypedReducer<AppState, CreateAppSuccessAction>(_createAppSuccess),
  TypedReducer<AppState, UpdateAppSuccessAction>(_updateAppSuccess),
]);

// Get Apps
AppState _getAppsSuccess(AppState state, GetAppsSuccessAction action) {
  return state.rebuild(
    (b) => b..apps = action.apps.toBuilder(),
  );
}

// Get App By ID
AppState _getAppByIDSuccess(AppState state, GetAppByIDSuccessAction action) {
  return state.rebuild(
    (b) => b..appsByID[action.app.id] = action.app,
  );
}

// Update App
AppState _updateAppSuccess(AppState state, UpdateAppSuccessAction action) {
  return state;
}

// Create App
AppState _createAppSuccess(AppState state, CreateAppSuccessAction action) {
  return state.rebuild(
    (b) => b..appsByID[action.app.id] = action.app,
  );
}

// Delete App
AppState _deleteAppSuccess(AppState state, DeleteAppSuccessAction action) {
  return state;
}
