import 'dart:convert';

import 'package:account_kit/entities/app/app.dart';
import 'package:account_kit/serializers.dart';
import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'appState.g.dart';

abstract class AppState implements Built<AppState, AppStateBuilder> {
  AppState._();
  factory AppState([updates(AppStateBuilder b)]) = _$AppState;

  static AppState initial() {
    return new AppState((b) => b..appsByID = MapBuilder<int, App>());
  }

  BuiltList<App>? get apps;
  BuiltMap<int, App>? get appsByID;

  String toJson() {
    return json.encode(serializers.serializeWith(AppState.serializer, this));
  }

  static AppState? fromJson(jsonString) {
    return serializers.deserializeWith(
        AppState.serializer, json.decode(jsonString));
  }

  static Serializer<AppState> get serializer => _$appStateSerializer;
}
