import 'package:account_kit/redux/organization/organizationActions.dart';
import 'package:redux/redux.dart';

import 'organizationState.dart';

final organizationReducer = combineReducers<OrganizationState>([
  TypedReducer<OrganizationState, GetOrganizationsSuccessAction>(
      _getOrganizationsSuccess),
  TypedReducer<OrganizationState, GetOrganizationByIDSuccessAction>(
      _getOrganizationByIDSuccess),
  TypedReducer<OrganizationState, DeleteOrganizationSuccessAction>(
      _deleteOrganizationSuccess),
  TypedReducer<OrganizationState, CreateOrganizationSuccessAction>(
      _createOrganizationSuccess),
  TypedReducer<OrganizationState, UpdateOrganizationSuccessAction>(
      _updateOrganizationSuccess),
]);

// Get Organizations
OrganizationState _getOrganizationsSuccess(
    OrganizationState state, GetOrganizationsSuccessAction action) {
  return state.rebuild(
    (b) => b..organizations = action.organizations.toBuilder(),
  );
}

// Get Organization By ID
OrganizationState _getOrganizationByIDSuccess(
    OrganizationState state, GetOrganizationByIDSuccessAction action) {
  return state.rebuild(
    (b) => b..organizationsByID[action.organization.id] = action.organization,
  );
}

// Update Organization
OrganizationState _updateOrganizationSuccess(
    OrganizationState state, UpdateOrganizationSuccessAction action) {
  return state;
}

// Create Organization
OrganizationState _createOrganizationSuccess(
    OrganizationState state, CreateOrganizationSuccessAction action) {
  return state.rebuild(
    (b) => b..organizationsByID[action.organization.id] = action.organization,
  );
}

// Delete Organization
OrganizationState _deleteOrganizationSuccess(
    OrganizationState state, DeleteOrganizationSuccessAction action) {
  return state;
}
