library serializers;

import 'package:account_kit/entities/accessToken/accessToken.dart';
import 'package:account_kit/entities/app/app.dart';
import 'package:account_kit/entities/group/group.dart';
import 'package:account_kit/entities/organization/organization.dart';
import 'package:account_kit/entities/request/request.dart';
import 'package:account_kit/entities/services/services.dart';
import 'package:account_kit/entities/user/user.dart';
import 'package:account_kit/redux/accessToken/accessTokenState.dart';
import 'package:account_kit/redux/accountKitState.dart';
import 'package:account_kit/redux/app/appState.dart';
import 'package:account_kit/redux/group/groupState.dart';
import 'package:account_kit/redux/organization/organizationState.dart';
import 'package:account_kit/redux/user/userState.dart';
import 'package:built_collection/built_collection.dart';
import 'package:built_value/serializer.dart';
import 'package:built_value/standard_json_plugin.dart';

// import 'error/commonError.dart';
// import 'error/errorState.dart';

part 'serializers.g.dart';

/// Example of how to use built_value serialization.
///
/// Declare a top level [Serializers] field called serializers. Annotate it
/// with [SerializersFor] and provide a `const` `List` of types you want to
/// be serializable.
///
/// The built_value code generator will provide the implementation. It will
/// contain serializers for all the types asked for explicitly plus all the
/// types needed transitively via fields.
///
/// You usually only need to do this once per project.
@SerializersFor([
  // ErrorState,
  AccountKitState,
  UserState,
  User,
  Organization,
  OrganizationState,
  AccessToken,
  AccessTokenState,
  App,
  Request,
  Services,
  GroupState,
  Group,
])
final Serializers serializers =
    (_$serializers.toBuilder()..addPlugin(new StandardJsonPlugin())).build();
final Serializers rawSerializer = _$serializers;
